local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("salemWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = false
		disableMovement()
		
		local salem = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("salem")
		salem.Maxspeed = 60
		local victor = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("victor")
		victor.Maxspeed = 40
		victor:SetHorizontalScale(-1)

		theo = celeste.NPC(player.Position - vector2(20, 0))
        level:Add(theo)
        local sprite = celeste.GFX.SpriteBank:Create("theo")
        theo:Add(sprite)
        theo.Sprite = sprite
		theo.Maxspeed = 60

		level:ZoomSnap(vector2(160, 120), 1.7)
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(16210, -2310), 0.1)))
		wait(0.1)
		setFlag("rocket-end", false)
		wait(3.0)
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(16110, -2310), 4.0)))
		wait(3.0)
		player.Facing = getEnum("Celeste.Facings", "Left")
		wait(1.0)
		player.Facing = getEnum("Celeste.Facings", "Right")
		wait(1.0)
		say("SSC2024_fonda_bar01")
		wait(0.2)
		salem:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_bar02")
		wait(0.2)
		salem:SetHorizontalScale(1)
		wait(0.2)
		say("SSC2024_fonda_bar03")
		salem:SetHorizontalScale(-1)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(player.Position.X + 24, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_bar04")
		salem.Maxspeed = 40
		salem:SetHorizontalScale(1)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(player.Position.X + 72, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_bar05")
		wait(0.2)
		salem:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_bar06")
		sprite:Play("walk", false, false)
		coroutine.yield(theo:MoveTo(vector2(player.Position.X + 30, theo.Y)))
		sprite:Play("idle", false, false)
		say("SSC2024_fonda_bar07")
		wait(0.2)
		sprite.Scale = vector2(-1,1)
		wait(0.2)
		say("SSC2024_fonda_bar08")
		wait(0.2)
		sprite.Scale = vector2(1,1)
		wait(0.2)
		say("SSC2024_fonda_bar09")
		wait(0.2)
		salem:SetHorizontalScale(1)
		wait(0.2)
		say("SSC2024_fonda_bar10")
		wait(0.2)
		salem:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_bar11")
		wait(1.5)
		say("SSC2024_fonda_bar12")
		salem:PlayAnimation("salemwalk")
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(160, 140), 2.3, 1.0)))
		coroutine.yield(salem:MoveTo(vector2(player.Position.X + 48, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_bar13")
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(160, 120), 1.7, 3.0)))
		wait(2.5)
		salem:SetHorizontalScale(1)
		say("SSC2024_fonda_bar14")

		setFlag("rocket-end", true)
		wait(2.0)
		salem.Position = vector2(player.Position.X, player.Position.Y + 300)
		victor.Position = vector2(player.Position.X, player.Position.Y + 300)
		setFlag("rocket-end", false)
		wait(3.0)
		say("SSC2024_fonda_bar15")
		wait(0.2)
		sprite.Scale = vector2(-1,1)
		wait(0.2)
		say("SSC2024_fonda_bar16")
		setFlag("rocket-end", true)
		wait(2.5)
		setFlag("salemWatched", true)
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		getLevel():remove(coroutineEntity)
		enableMovement()
		setFlag("teleporting", true)
		wait(40.0)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("rocket-end", false)
		setFlag("salemWatched", true)
		setFlag("teleporting", true)
		enableMovement()
    end
end