local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("endhalcyonWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()

		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomTo(vector2(110, 100), 1.5, 2.0)))
		walkTo(8220, false, 0.7)
		say("SSC2024_fonda_endhalcyon01")
		walk(-25, false, 0.7)
		wait(0.7)
		playSound("event:/char/theo/resort_standtocrawl", player.Position)
		wait(0.7)
		walk(25, false, 0.7)
		player.Facing = getEnum("Celeste.Facings", "Left")
		wait(2.0)
		say("SSC2024_fonda_endhalcyon02")
		player.ForceCameraUpdate = false
		setFlag("rocket-end", true)
		setFlag("musicFade", true)
		wait(3.5)
		setFlag("teleporting", true)
		wait(15.5)

		setFlag("endhalcyonWatched", true)
		enableMovement()
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("endhalcyonWatched", true)
		setFlag("teleportingskip", true)
		enableMovement()
    end
end