local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("endvalhallaWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()
		
		local salem = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("salem")
		salem.Maxspeed = 60
		local victor = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("victor")
		victor.Maxspeed = 40

		player.Sprite:Play("walk")
		coroutineEntity:add(monocle.Coroutine(player:DummyWalkTo(30248, false, 0.7)))
		setFlag("rocket-end", true)
		wait(1.5)
		player.ForceCameraUpdate = false
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(30130, -8014), 0.1)))
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomTo(vector2(160, 100), 1.5, 0.1)))
		wait(1.0)

		theo = celeste.NPC(player.Position - vector2(20, 0))
        level:Add(theo)
        local sprite = celeste.GFX.SpriteBank:Create("theo")
        theo:Add(sprite)
        theo.Sprite = sprite
		theo.Maxspeed = 60

		playMusic("event:/moladan/A Hat in Time OST [Nyakuza Metro] - Rumbi Factory")
		setFlag("rocket-end", false)
		wait(2.0)
		say("SSC2024_fonda_endvalhalla01")
		wait(0.2)
		victor:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_endvalhalla02")
		wait(0.2)
		victor:SetHorizontalScale(1)
		wait(0.2)
		say("SSC2024_fonda_endvalhalla03")
		wait(0.2)
		victor:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_endvalhalla04")
		wait(1.0)
		say("SSC2024_fonda_endvalhalla06")
		salem:SetHorizontalScale(1)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X + 80, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(1.0)
		say("SSC2024_fonda_endvalhalla07")
		wait(1.0)
		say("SSC2024_fonda_endvalhalla08")
		wait(3.0)
		say("SSC2024_fonda_endvalhalla09")
		salem.Maxspeed = 40
		salem:SetHorizontalScale(-1)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X - 80, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_endvalhalla10")
		salem.Maxspeed = 90
		salem:PlayAnimation("salemwalk")
		playSound("event:/ui/main/whoosh_large_out", player.Position)
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(120, 120), 2.3, 1.2)))
		coroutine.yield(salem:MoveTo(vector2(player.Position.X + 16, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_endvalhalla11")
		wait(0.2)
		wait(0.2)
		say("SSC2024_fonda_endvalhalla12")
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(120, 125), 3.0, 2.5)))
		wait(1.0)
		say("SSC2024_fonda_endvalhalla14")
		wait(0.7)
		say("SSC2024_fonda_endvalhalla18")
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(120, 120), 2.3, 2.0)))
		wait(2.0)
		say("SSC2024_fonda_endvalhalla15")
		salem.Maxspeed = 60
		salem:PlayAnimation("salemwalk")
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(160, 100), 1.5, 2.0)))
		coroutine.yield(salem:MoveTo(vector2(salem.X - 150, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_endvalhalla16")
		walk(-150)
		say("SSC2024_fonda_endvalhalla17")
		setFlag("rocket-end", true)
		wait(2.0)
		setFlag("teleporting", true)
		wait(40.0)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("rocket-end", false)
		setFlag("endvalhallaWatched", true)
		setFlag("teleportingskip", true)
		enableMovement()
    end
end