local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("graveWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = false
		disableMovement()
		
		local salem = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("salem")
		salem.Maxspeed = 20

		level:ZoomSnap(vector2(160, 120), 1.5)
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(32164, -7644), 0.1)))
		wait(5.0)
		setFlag("rocket-end", false)
		wait(5.0)
		setFlag("sky", true)
		wait(5.0)
		say("SSC2024_fonda_grave01")
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(32164, -7430), 4.0)))
		wait(4.5)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X + 50, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(2.0)
		say("SSC2024_fonda_grave02")
		wait(0.2)
		salem:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_grave03")
		salem:SetHorizontalScale(1)
		salem.Maxspeed = 40
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X + 20, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_grave04")
		wait(0.5)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X - 10, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(1.0)
		salem:SetHorizontalScale(-1)
		wait(0.5)
		say("SSC2024_fonda_grave05")
		salem.Maxspeed = 60
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(180, 120), 2.3, 1.5)))
		salem:PlayAnimation("salemwalk")
		salem:SetHorizontalScale(1)
		coroutine.yield(salem:MoveTo(vector2(salem.X + 30, salem.Y)))
		salem:PlayAnimation("salemidle")
		say("SSC2024_fonda_grave06")
		salem.Maxspeed = 30
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(160, 120), 1.5, 2.0)))
		salem:SetHorizontalScale(-1)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X - 20, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(2.0)
		say("SSC2024_fonda_grave07")
		wait(2.0)
		salem:SetHorizontalScale(1)
		wait(0.2)
		say("SSC2024_fonda_grave08")
		wait(1.0)
		salem:SetHorizontalScale(-1)
		wait(0.4)
		salem:PlayAnimation("salemwalk")
		coroutineEntity:add(monocle.Coroutine(salem:MoveTo(vector2(salem.X - 100, salem.Y))))
		wait(2.5)
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(32164, -7644), 4.0)))
		wait(5.0)
		say("SSC2024_fonda_grave09")
		wait(1.0)
		setFlag("sky", false)
		wait(5.0)
		setFlag("rocket-end", true)
		wait(3.0)
		setFlag("teleporting", true)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("rocket-end", false)
		setFlag("graveWatched", true)
		setFlag("sky", true)
		setFlag("teleportingskip", true)
		enableMovement()
    end
end