local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("halcyonWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()
		
		theo = celeste.NPC(player.Position + vector2(35, 0))
        level:Add(theo)
        local sprite = celeste.GFX.SpriteBank:Create("theo")
        theo:Add(sprite)
        theo.Sprite = sprite
		theo.Maxspeed = 45

		wait(0.5)
		level:ZoomSnap(vector2(120, 100), 1.5)
		setFlag("rocket-end", false)
		walk(15)
		wait(1.0)
		say("SSC2024_fonda_halcyon04")
		sprite.Scale = vector2(-1,1)
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(105, 110), 2, 1.5)))
		wait(2.0)
		say("SSC2024_fonda_halcyon05")
		wait(0.7)
		say("SSC2024_fonda_halcyon06")
		setFlag("rocket-end", true)
		wait(2.0)
		coroutine.yield(level:ZoomBack(0.1))
		theo:RemoveSelf()
		wait(0.4)
		setFlag("rocket-end", false)
		setFlag("halcyonWatched", true)
		enableMovement()
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		theo:RemoveSelf()
		setFlag("rocket-end", false)
		setFlag("halcyonWatched", true)
		enableMovement()
    end
end