local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

local spotlight = require("#Celeste.SpotlightWipe")
local screenwipe = require("#Celeste.ScreenWipe")

function onBegin()
	if not getFlag("morning2Watched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()
		
		theo = celeste.NPC(player.Position + vector2(20, 0))
        level:Add(theo)
        local sprite = celeste.GFX.SpriteBank:Create("theo")
        theo:Add(sprite)
        theo.Sprite = sprite
		theo.Maxspeed = 45

		spotlight.FocusPoint = player.Position - getRoom().Camera.Position
		local wipe = spotlight(getRoom(), true)
		wipe.Duration = 2
		wait(wipe.Duration)

		wait(0.5)
		say("SSC2024_fonda_morning04")
		wait(0.5)
		player.ForceCameraUpdate = false
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(1487, -644), 3.0)))
		wait(3.5)
		say("SSC2024_fonda_morning05")
		wait(0.5)
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(return_pos, 3.0)))
		wait(3.5)
		say("SSC2024_fonda_morning06")
		player.ForceCameraUpdate = true

		sprite:Play("walk", false, false)
		coroutineEntity:add(monocle.Coroutine(theo:MoveTo(vector2(player.Position.X + 550, theo.Y))))
		wait(0.1)
		coroutineEntity:add(monocle.Coroutine(walk(450, false, 0.7)))
		wait(20.0)
		--setFlag("morning2Watched", true)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("teleportingskip", true)
		setFlag("morningWatched", true)
		enableMovement()
    end
end