local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()
local sfxSoundSource1 = celeste.SoundSource()
local sfxSoundSource2 = celeste.SoundSource()

function onBegin()
	if not getFlag("endingWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()

		local salem = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("salem")
		salem.Maxspeed = 30

		level:ZoomSnap(vector2(150, 115), 1.5)
		wait(0.5)
		setFlag("rocket-end", false)
		wait(4.0)
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X + 120, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(1.0)
		say("SSC2024_fonda_postcredits01")
		wait(1.0)
		salem:SetHorizontalScale(-1)
		wait(0.5)
		say("SSC2024_fonda_postcredits02")
		wait(0.2)
		salem:SetHorizontalScale(1)
		wait(0.2)
		say("SSC2024_fonda_postcredits03")
		wait(1.5)
		say("SSC2024_fonda_postcredits04")
		wait(0.5)
		salem:SetHorizontalScale(-1)
		wait(0.5)
		salem.Maxspeed = 20
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X - 20, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(1.0)
		salem:SetHorizontalScale(1)
		wait(2.5)
		salem.Maxspeed = 35
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X + 100, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(1.5)
		playSound("event:/game/general/strawberry_pulse", player.Position)
		playSound("event:/game/04_cliffside/arrowblock_side_depress", player.Position)
		setFlag("flower1", true)
		wait(1.0)
		salem:SetHorizontalScale(-1)
		salem.Maxspeed = 25
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X - 48, salem.Y)))
		salem:PlayAnimation("salemidle")
		wait(0.5)
		salem:SetHorizontalScale(1)
		wait(1.0)
		playSound("event:/game/general/strawberry_pulse", player.Position)
		playSound("event:/game/04_cliffside/arrowblock_side_depress", player.Position)
		setFlag("flower2", true)
		wait(1.0)
		salem:SetHorizontalScale(-1)
		wait(1.0)
		salem.Maxspeed = 40
		salem:PlayAnimation("salemwalk")
		coroutine.yield(salem:MoveTo(vector2(salem.X - 130, salem.Y)))
		salem:PlayAnimation("salemidle")
		setFlag("rocket-end", true)
		wait(5.0)
		setFlag("teleporting", true)
		wait(30.0)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("teleportingskip", true)
		enableMovement()
    end
end