local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("theocall1Watched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()

		wait(0.5)
		playSound("event:/moladan/radio", player.Position)
		wait(1.0)
		playSound("event:/game/01_forsaken_city/console_static_long", player.Position)
		say("SSC2024_fonda_theocall01")
		coroutine.yield(getLevel():ZoomTo(vector2(160, 70), 1.5, 2.0))
		say("SSC2024_fonda_theocall02")
		walk(-15)
		say("SSC2024_fonda_theocall03")
		walk(20)
		say("SSC2024_fonda_theocall04")
		playSound("event:/ui/main/whoosh_large_out", player.Position)
		wait(0.1)
		setFlag("white", true)
		wait(0.25)
		setFlag("teleporting", true)
		wait(20)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("theocall1Watched", true)
		enableMovement()
    end
end