local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("valhallaWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = true
		disableMovement()
		
		wait(0.5)
		setFlag("rocket", false)
		player.ForceCameraUpdate = false
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(9662, -532), 5)))
		wait(1.0)
		setFlag("smoke", true)
		wait(6.0)
		setFlag("smoke", false)
		wait(1.0)
		setFlag("rocket-end", true)
		wait(1.0)
		setFlag("teleporting", true)
	end
end

function onEnd(room, wasSkipped)
	getLevel():remove(coroutineEntity)
    if wasSkipped then
		player.ForceCameraUpdate = true
		player.DummyAutoAnimate = true
		setFlag("teleportingskip", true)
		setFlag("valhallaWatched", true)
		enableMovement()
    end
end