local engine = require("#monocle.engine")
local monocle = require("#monocle")
local celeste = require("#celeste")

local coroutineEntity = monocle.Entity()

function onBegin()
	if not getFlag("victorWatched") then
		local level = getLevel()
		local luanet = _G.luanet
		local return_pos = getLevel().Camera.Position
		level:add(coroutineEntity)
		vector = player.Position + vector2(0, 0)
		player.ForceCameraUpdate = false
		disableMovement()
		
		local victor = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("victor")
		theo = celeste.NPC(vector2(player.Position.X - 90, -5296))

		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomTo(vector2(160, 100), 1.5, 2.0)))
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(23008, -5424), 1.5)))
		walkTo(23144, false, 0.7)
		wait(0.5)
		say("SSC2024_fonda_victor01")
		player.Facing = getEnum("Celeste.Facings", "Left")

        level:Add(theo)
        local sprite = celeste.GFX.SpriteBank:Create("theo")
        theo:Add(sprite)
        theo.Sprite = sprite
		theo.Maxspeed = 80

		sprite:Play("run", false, false)
		coroutine.yield(theo:MoveTo(vector2(player.Position.X - 20, theo.Y)))
		sprite:Play("tired", false, false)
		wait(1.5)
		say("SSC2024_fonda_victor02")
		sprite:Play("idle", false, false)
		player.Facing = getEnum("Celeste.Facings", "Right")
		wait(0.4)
		say("SSC2024_fonda_victor03")
		wait(0.2)
		victor:SetHorizontalScale(1)
		wait(0.2)
		say("SSC2024_fonda_victor05")
		wait(0.2)
		victor:SetHorizontalScale(-1)
		wait(0.2)
		say("SSC2024_fonda_victor06")
		wait(0.8)
		victor:SetHorizontalScale(1)
		wait(0.5)
		say("SSC2024_fonda_victor07")
		wait(0.5)
		victor:SetHorizontalScale(-1)
		wait(0.5)
		say("SSC2024_fonda_victor08")
		setFlag("rocket-end", true)
		wait(1.5)
		coroutine.yield(level:ZoomBack(0.1))
		victor.Position = vector2(player.Position.X, player.Position.Y + 300)
		theo:RemoveSelf()
		wait(1.5)
		setFlag("rocket-end", false)
	end
end

function onEnd(room, wasSkipped)
	setFlag("victorWatched", true)
	setFlag("rocket-end", false)
	if wasSkipped then
		local victor = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("victor")
		victor.Position = vector2(0,0)
		theo:RemoveSelf()
    end
	player.ForceCameraUpdate = true
	player.DummyAutoAnimate = true
	getLevel():remove(coroutineEntity)
	enableMovement()
end