local lua_helper = celeste.Mod.LuaCutscenes.LuaHelper
local monocle = require("#monocle")

local shuffleRoutine
local confettiRoutine
local coroutineEntity = monocle.Entity()

local violebula
local astrixie
local galaska
local rupulsar

local function makeCoroutine(func)
  return monocle.Coroutine(lua_helper.LuaCoroutineToIEnumerator(coroutine.create(func)))
end

local function shuffleABitRoutine()
	wait(1)
	walk(-16)
	wait(1)
	walk(24)
end

-- bad bad doesnt work fuck me
local function spawnConfettiRoutine()
	playSound("event:/game/07_summit/checkpoint_confetti")
	getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(violebula.Position))
	getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(astrixie.Position))
	getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(rupulsar.Position))
	getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(galaska.Position))
end
	
function onBegin()
	local luanet = _G.luanet -- get luanet
	violebula = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("violebula")
	astrixie = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("astrixie")
	galaska = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("galaska")
	galaska:SetHorizontalScale(-1)
	rupulsar = celeste.Mod.MaxHelpingHand.Entities.MoreCustomNPC.GetNPC("rupulsar")
	rupulsar:SetHorizontalScale(-1)
	if getFlag("seenHubIntro") then
		astrixie.Position = vector2(0,0)
		violebula.Position = vector2(0,0)
		galaska.Position = vector2(0,0)
		rupulsar.Position = vector2(0,0)
	else
		getLevel().Lighting.Alpha = 1.0
		disableMovement()
		shuffleRoutine = makeCoroutine(shuffleABitRoutine)
		getLevel():add(coroutineEntity)
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomTo(vector2(160, 100), 2, 3)))
		player.ForceCameraUpdate = false
		cutsceneEntity:Add(shuffleRoutine)
		say("SecretSanta2024_3_Hard_bryse0n_hub")
		cutsceneEntity:Remove(shuffleRoutine)
		walkTo(2198)
	
		player.Facing = luanet.enum(luanet.import_type("Celeste.Facings"), "Left")
		say("SecretSanta2024_3_Hard_bryse0n_hub2")
		coroutine.yield(celeste.CutsceneEntity.CameraTo(vector2(getLevel().Camera.Position.X - 100, getLevel().Camera.Position.Y), 3))
		coroutineEntity:add(monocle.Coroutine(violebula:MoveTo(vector2(player.Position.X - 72, violebula.Y))))
		coroutineEntity:add(monocle.Coroutine(astrixie:MoveTo(vector2(player.Position.X - 56, astrixie.Y))))
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(getLevel().Camera.Position.X + 100, getLevel().Camera.Position.Y), 3)))
		coroutine.yield(celeste.CutsceneEntity.CameraTo(vector2(2040, -7326), 0.5))
	
		player.Facing = luanet.enum(luanet.import_type("Celeste.Facings"), "Right")
		say("SecretSanta2024_3_Hard_bryse0n_hub3")
		coroutine.yield(celeste.CutsceneEntity.CameraTo(vector2(getLevel().Camera.Position.X + 100, getLevel().Camera.Position.Y), 3))
		coroutineEntity:add(monocle.Coroutine(galaska:MoveTo(vector2(player.Position.X + 56, galaska.Y))))
		coroutineEntity:add(monocle.Coroutine(rupulsar:MoveTo(vector2(player.Position.X + 72, rupulsar.Y))))
		coroutineEntity:add(monocle.Coroutine(celeste.CutsceneEntity.CameraTo(vector2(getLevel().Camera.Position.X - 100, getLevel().Camera.Position.Y), 3)))
		coroutine.yield(celeste.CutsceneEntity.CameraTo(vector2(2048, -7326), 0.5))
		
		say("SecretSanta2024_3_Hard_bryse0n_hub4")
		playMusic("event:/bryse0n/primeoperator")
		setFlag("hubMusicStarted", true)
		wait(1)
		getLevel().Lighting.Alpha = 0.12
		coroutineEntity:add(monocle.Coroutine(getLevel():ZoomAcross(vector2(160, 80), 1.25, 2.5)))
		--playSound("event:/game/07_summit/checkpoint_confetti")
		--getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(violebula.Position))
		--getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(astrixie.Position))
		--getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(rupulsar.Position))
		--getLevel():Add(celeste.SummitCheckpoint.ConfettiRenderer(galaska.Position))
		wait(5)
		say("SecretSanta2024_3_Hard_bryse0n_hub5")
		coroutine.yield(getLevel():ZoomAcross(vector2(160, 100), 2, 1.5))
		say("SecretSanta2024_3_Hard_bryse0n_hub6")
		player.Facing = luanet.enum(luanet.import_type("Celeste.Facings"), "Left")
		coroutine.yield(astrixie:MoveTo(vector2(player.Position.X - 24, astrixie.Y)))
		say("SecretSanta2024_3_Hard_bryse0n_hub7")
		astrixie:SetHorizontalScale(-1)
		say("SecretSanta2024_3_Hard_bryse0n_hub8")
		astrixie:SetHorizontalScale(1)	
		say("SecretSanta2024_3_Hard_bryse0n_hub9")
		setFlag("hub_intro_done", true)
		makeUnskippable()
		disableRetry()
		wait(3)
		astrixie.Position = vector2(0,0)
		violebula.Position = vector2(0,0)
		galaska.Position = vector2(0,0)
		rupulsar.Position = vector2(0,0)
		getLevel():ResetZoom()
		setFlag("hub_intro_done", false)
		wait(1.5)
		setFlag("seenHubIntro", true)
	end
end

function onEnd(room, wasSkipped)
	if wasSkipped then
		getLevel():ResetZoom()
		astrixie.Position = vector2(0,0)
		violebula.Position = vector2(0,0)
		galaska.Position = vector2(0,0)
		rupulsar.Position = vector2(0,0)
		setFlag("seenHubIntro", true)
	end
	if not getFlag("hubMusicStarted") then
		playMusic("event:/bryse0n/primeoperator")
	end
	setFlag("hub_intro_done", false)
	setFlag("seenHubIntro", true)
	getLevel().Lighting.Alpha = 0.12
	getLevel():ResetZoom()
	enableMovement()
	enableRetry()
end